cmd = {};

//commandsHash = {"ls":1,"dir":1};

cmd.client_commands = {"":0,"clear":1, "help":2};
cmd.mixed_commands = {"rm":0,"make":1, "gcc":2, "gpp":3, "run":4};

cmd.history = new Array();
cmd.history[0] = "";
cmd.history_index = 0;

//cmd.cwd = '';


cmd.exec = function(str) {
	//Mostramos la imagen de carga
	document.getElementById("result_loading").style.display = "block";
	
	if(str) {
		//gE("cmdInput").value=str;
		alert("str: "+str);
		document.getElementById("cmd_input").value = str;
	}
	//var comStr = gE("cmdInput").value;
	var comStr = document.getElementById("cmd_input").value;
	
	//alert(comStr);
	
	var m = comStr.match(/\w+/);
	
	//alert(m);
	
	var com = (m && m.length) ? m[0] : "";
	cmd.hide();
	//cmd.echo(document.getElementById("cmd_prompt").innerHTML.replace("&gt;",">")+comStr);
	cmd.echo(document.getElementById("cmd_prompt").innerHTML+comStr);
	
	//Acciones para el historial
	cmd.history.push(comStr);
	cmd.history_index = 0;
	
	//alert(com);
	//alert(m[0]);
	
	//if(command in commandsHash || command=="run" || is_input){
	if(com in cmd.client_commands){
	//correct
	//server code here
		//alert("Command "+command+" is recognized")
		//alert("run");
		cmd.run(com, comStr);
	} 
	else if (com in cmd.mixed_commands) {
		cmd.send(com, comStr);
		var filetree_document = document.getElementById("filetree").contentDocument;
		filetree_document.location.reload();
	}
	/*
	else {
	//incorrect
		cmd.echo("Incorrect command");
		cmd.echo("Type 'help'");
		//process_finished()
	}
	*/
	else {
		//alert("send");
		cmd.send(com, comStr);	
	}
	
	document.getElementById("cmd_area").scrollTop = 1000000;
	document.getElementById("cmd_input").value = "";

	//Ocultamos la imagen de carga
	document.getElementById("result_loading").style.display = "none";


}


cmd.send = function(com, comStr) {
	var ajax_obj = new Ajax();
	var url = "cmd/cmd.php?";
	var parameters = "com="+com+"&comStr="+comStr;
	var response = ajax_obj.request_synchronous_text(url, parameters);
	cmd.echo(response);
}

cmd.run = function(com, comStr) {
	//var cmd_text = document.getElementById("cmd_text");
	var response;
	switch(com) {
		case "clear":
			document.getElementById("cmd_text").innerHTML = "<PRE>webDevStudio Command Line</PRE>";
			cmd.show();
			//alert(cmd_text);
			break;
		case "help":
			//alert("entra");
			 response = ""+
				"Available commands:\n"+
				"  clear - clear command line screen\n"+
				"  dir   - list directory contents\n"+
			  "  ls    - list directory contents\n"+
				"  rm    - remove files or directories\n"+
				"  gcc   - GNU project C compiler\n"+
				"  g++   - GNU project C++ compiler\n"+
				"  make  - GNU make utility to maintain groups of programs\n"+
				"  run   - execute program";
			//alert(cmd_text);
			cmd.echo(response);
			break;
		default:
			response = com+": Command not found";
			cmd.echo(response);
			break;
	}
	
	
}


cmd.hide = function() {
	//document.getElementById("cmd_input").value = "";
	document.getElementById("cmd_prompt").style.visibility = "hidden";
	document.getElementById("cmd_input").blur();
}

cmd.show = function(txt) {
	document.getElementById("cmd_prompt").style.visibility = "visible";
	cmd.focus();
	//document.getElementById("cmd_prompt").innerHTML = (txt || cmd.currentDir)+">"
}

cmd.focus = function() {
	try {
		if(document.getElementById("cmd_prompt").style.visibility != 'hidden') {
			document.getElementById("cmd_input").focus();
		}
	} 
	catch(e) {
	}
}

cmd.echo = function(str) {

	var ua = navigator.userAgent;
	if(ua.match('MSIE')) {
		//Preparamos el string para IE
		str = str.replace(/\n/g, "\n\r");
	}

	var node = document.createElement("pre");
	node.appendChild(document.createTextNode(str));
	document.getElementById("cmd_text").appendChild(node);
	cmd.show();
}

cmd.key = function(evt) {
	var key = evt.keyCode;
	if(key == 38) {
		var index = cmd.history.length - Math.abs(cmd.history_index % cmd.history.length+1);
		++cmd.history_index;
		document.getElementById("cmd_input").value = cmd.history[index];
		cmd.resize();
	}
	else if (key == 40) {
		++cmd.history_index;
		var index = Math.abs(cmd.history_index % cmd.history.length);
		document.getElementById("cmd_input").value = cmd.history[index];
		cmd.resize();
	}
	else {
		cmd.resize();
	}
}

cmd.resize = function() {
	var input = document.getElementById("cmd_input");
	input.size = input.value.length + 2;
}



