<?php
/*
webDevStudio
Copyright (C) 2005 Alberto Martnez Fernndez (albertinho_2000@hotmail.com)
                   Israel Ortiz Flores (i_ortiz_flores@hotmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("../authentication.php");

//Funcion que indica si la extension de un fichero est permitida
function check_extension($filename,$extensions) {
	for ($j=0; $j<count($extensions); $j++) {
		//Permitimos los ficheros que son del mismo lenguaje
		$long_extension=strlen($extensions[$j]);
		$extension_file=strtolower(substr($filename, strlen($filename)-$long_extension, $long_extension));
		if ($extension_file==$extensions[$j]) {
			return 1;
		}
		//Permitimos los ficheros de texto
		else if (strtolower(substr($filename, strlen($filename)-4, 4))==".txt" ) {
			return 1;
		}
	}
	return 0;
}

//Comprobamos si se ha permitido subir el fichero
if (isset($_FILES['file']['tmp_name']) &&
	isset($_FILES['file']['size']) &&
	isset($_FILES['file']['name']) ) {
	
	$user=$_SESSION['s_user'];
	$languaje=$_SESSION['s_languaje'];
	$name=$_SESSION['s_name'];
	
	$filename= $_FILES['file']['name'];
	$filesize= $_FILES['file']['size'];
	$pathfile="../users/$user/$name/$filename";

	require("../compile_config.php");
	
	//Compromamos si el fichero que han subido es correcto
	$error=0;
	if ($filename=="") {
    	$mensaje= "All obligatory fields must be completed";
		$error=1;
	}
	else if (!check_extension($filename, $extensions[$languaje])) {
		$mensaje="This file cannot be upload<br><br>Only you can upload \"". $languaje."\" files or \".txt\" files";
		$error=1;
	}
	else if (strlen($filename) > 12) {
		$mensaje="Name of file too long.<br><br>Only 8 characters are admitted";
		$error=1;
	}
	/*
	else if (mime_content_type($file)!="text/plain") {
		$mensaje="This file cannot be upload.<br><br>Only you can upload plain text files";
		$error=1;
	}
	*/
	else if ($filesize > 512000) {
   		$mensaje= "The size of the file must be inferior to 500 KBytes";
		$error=1;
	}
	else if (ereg("[\\/:*?\"<>|\']", $filename) == TRUE) {
		$mensaje="The name of the file is incorrect.<BR><BR>Please, don't use: \,/,:,*,?,\",<,>,|,'";
		$error=1;
	}
	//else if (file_exists("./users/$user/$name/$file_name")) {
	else if (file_exists($pathfile)) {
		$mensaje='There is another file with this "'.$filename.'" file name';
		$error=1;
	}
	//El formulario est correctamente rellenado
	else {
		$file=$_FILES['file']['tmp_name'];
		if (!copy($file, $pathfile)) {
			$mensaje="There have been problems on updating the file";
			$error=1;
    	}
	}
}
//No se ha permitido subir el fichero
else {
    $mensaje= "The size of the file must be inferior to 500 KBytes";
	$error=1;
}

//Tratamos los errores
if ($error!=1) {
   	//header("Location: work_project.php?name=".urlencode($name)."&languaje=".urlencode($languaje)."&platform=".urlencode($platform)."&application=".urlencode($application)."&file=".urlencode($file_name));
	$_SESSION['s_file']=$filename;
	header("Location: work_project.php");
}
else {
	echo '
		<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html>
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<title>webDevStudio :: Upload a local file</title>
		<link href="../style.css" rel="stylesheet" type="text/css">

		<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
			function volver()
			{
	  			history.back()
			}
		</SCRIPT>

		</head>
		<body>';
	include("head_project.php");
	echo '<table width="780" border="0" cellspacing="0" cellpadding="0">
		  <tr>
		    <td colspan="5" height="25"></td>
		  </tr>
		  <tr>
		    <td width="19" valign="top"></td>
		    <td width="244" height="72" valign="top">
					<!--
			   	<img src="../images/logo_projects.png" width="105" height="119" alt="My Projects">
  		    <br>
	        <font class="Estilo2">My Projects</font>
					-->
				<table width="231" border="0" cellspacing="0" cellpadding="0" bgcolor="#ededed">
					<tr>
						<td><img src="../images/cab_projects.png" alt="Description" width="231" height="45" /></td>
					</tr>
					<tr>
						<td height="22"><img src="../images/flechita_menu.png" style="margin-left:7px; margin-right:8px"/><a href="#" class="txt_login" onClick="volver()">Back</a></td>
					</tr>
					<tr>
						<td height="1" bgcolor="#FFFFFF"></td>
					</tr>
				</table>
			</td>
		    <td width="20"></td>
		    <!--<td width="46" valign="top"></td>-->
		    <td width="*" valign="top"><br>
					<span class="Estilo9">Sorry, there are errors in the form</span><br>
					<p class="Estilo12">'.$mensaje.'</p>
					<p><input type="button" name="Back" value="Back" onCLick="volver()"></p>
				</td>
		  </tr>
		  <tr>
		    <td colspan="5" height="25"></td>
		  </tr>
		</table>';
		include("foot_project.php");
		echo '</body>
			</html>';
}
?>
